﻿using Loki.Utils;
using NUnit.Framework;

namespace Loki.Core.Test
{
    [TestFixture]
    public class EnumParserTest : AssertionHelper
    {

        [Test]
        public void TestFind()
        {
            Expect(
                EnumParser<TestResources>.ToText(TestResources.Resource1),
                EqualTo("Texte")
                );
        }

        [Test]
        public void TestNotFound()
        {
            Expect(
                EnumParser<TestResources>.ToText(TestResources.NotFoundResource),
                EqualTo("NotFoundResource")
                );
        }

        [Test]
        public void NotFoundManager()
        {
            Expect(
                EnumParser<TestNotFoundManagerResource>.ToText(TestNotFoundManagerResource.Test),
                EqualTo("Test")
                );
        }
    }
}
