﻿namespace Loki.Commands
{
    public static class ApplicationCommands
    {
        private static class Names
        {
            public const string START = "Application.Start";
            public const string EXIT = "Application.Exit";
            public const string OPEN = "Application.Open";
            public const string MESSAGE = "Application.Message";
            public const string WARNING = "Application.Warning";
            public const string ERROR = "Application.Error";
            public const string SAVE = "Application.Save";
            public const string REFRESH = "Application.Refresh";
            public const string EXPORT = "Application.Export";
            public const string UPDATESTATUS = "Application.UpdateStatus";
        }

        private static CommandManager _Manager = new CommandManager();

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand START = _Manager.Create(Names.START);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand OPEN = _Manager.Create(Names.OPEN);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand EXIT = _Manager.Create(Names.EXIT);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand MESSAGE = _Manager.Create(Names.MESSAGE);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand WARNING = _Manager.Create(Names.WARNING);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand ERROR = _Manager.Create(Names.ERROR);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand EXPORT = _Manager.Create(Names.EXPORT);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand SAVE = _Manager.Create(Names.SAVE);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand REFRESH = _Manager.Create(Names.REFRESH);

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Security", "CA2104:DoNotDeclareReadOnlyMutableReferenceTypes", Justification = "ICommand is immutable")]
        public static readonly ICommand UPDATESTATUS = _Manager.Create(Names.UPDATESTATUS);
    }
}