﻿namespace Loki.Data
{
    /// <summary>
    /// Base interface for data entities.
    /// </summary>
    /// <typeparam name="TKeyType">Entity key type.</typeparam>
    public interface IDataEntity<TKeyType>
    {
        /// <summary>
        /// Gets or sets the data entity key.
        /// </summary>
        TKeyType PK { get; set; }

        /// <summary>
        /// Gets or sets a value indicating whether [already persisted].
        /// </summary>
        /// <value>
        ///   Is <c>true</c> if this instance already exist in data store; otherwise, <c>false</c>.
        /// </value>
        bool AlreadyPersisted { get; set; }
    }
}
