﻿using System;
using System.Collections.Generic;
using System.Data;
using Loki.Data;
using Loki.Utils;

namespace Loki.Engine
{
    public abstract class LokiDataProvider<TDataContext> : LokiService, IDataProvider
        where TDataContext : class, IObjectCreator
    {
        public virtual void Initialize()
        {
        }

        public virtual TDataContext DataContext
        {
            get { return ToolKit.Engine.GetDataModel<TDataContext>(); }
        }

        public IDatabaseAdapter Database { get; set; }

        protected IEnumerable<T> WrapperTransactional<T>(Func<IDbTransaction, IEnumerable<T>> P_Wrapped)
        {
            return Database.WrapperTransactional<T>(P_Wrapped);
        }

        protected T WrapperTransactional<T>(Func<IDbTransaction, T> P_Wrapped)
        {
            return Database.WrapperTransactional<T>(P_Wrapped);
        }

        protected void WrapperTransactional(Action<IDbTransaction> P_Wrapped)
        {
            Database.WrapperTransactional(P_Wrapped);
        }

        protected IEnumerable<T> WrapperTransactional<T>(Func<IDbTransaction, IEnumerable<T>> P_Wrapped, IsolationLevel P_Level)
        {
            return Database.WrapperTransactional<T>(P_Wrapped, P_Level);
        }

        protected T WrapperTransactional<T>(Func<IDbTransaction, T> P_Wrapped, IsolationLevel P_Level)
        {
            return Database.WrapperTransactional<T>(P_Wrapped, P_Level);
        }

        protected void WrapperTransactional(Action<IDbTransaction> P_Wrapped, IsolationLevel P_Level)
        {
            Database.WrapperTransactional(P_Wrapped, P_Level);
        }
    }
}