﻿using System.Collections.Generic;
using Loki.Utils;

namespace Loki.Engine
{
    public class LokiContextInstaller : LokiObject, IContextInstaller
    {
        public virtual void Install(IObjectContext P_Context)
        {
            foreach (var L_Installer in _Installers)
            {
                L_Installer.Install(P_Context);
            }
        }

        public IContextInstaller Merge(params IContextInstaller[] P_Installers)
        {
            _Installers.AddRange(P_Installers);
            return this;
        }

        private List<IContextInstaller> _Installers = new List<IContextInstaller>();
    }
}