﻿using Loki.Commands;
using Loki.Engine.Registration;
using Loki.Utils;

namespace Loki.Engine
{
    internal class LokiServicesInstaller : LokiContextInstaller
    {
        public override void Install(IObjectContext P_Context)
        {
            P_Context.Register(Element.Service<ILogService, LokiLogService>());
            P_Context.Register(Element.Service<IErrorService, LokiErrorService>());
            P_Context.Register(Element.Service<ICommandService, LokiCommandService>());
            P_Context.Register(Element.For<IEngine>().Instance(ToolKit.Extensions.Engine));
            P_Context.Register(Element.Service<IEventService, LokiEventService>());
            P_Context.Register(Element.Service<ITaskService, LokiTaskService>());
            P_Context.Register(Element.Service<ISettingsService, LokiSettingsService>());
        }
    }
}