﻿namespace Loki.Engine.Registration
{
    public class Livestyle<TService> where TService : class
    {
        public LifestyleType Type { get; private set; }

        public int? PoolSizeMin { get; private set; }

        public int? PoolSizeMax { get; private set; }

        private ElementRegistration<TService> _Parent;

        public TService SingletonInstance { get; private set; }

        public Livestyle(ElementRegistration<TService> P_Parent)
        {
            _Parent = P_Parent;
            Type = LifestyleType.Singleton;
        }

        public ElementRegistration<TService> NoTracking
        {
            get
            {
                Type = LifestyleType.NoTracking;
                return _Parent;
            }
        }

        public ElementRegistration<TService> Pooled
        {
            get
            {
                Type = LifestyleType.Pooled;
                return _Parent;
            }
        }

        public ElementRegistration<TService> Singleton
        {
            get
            {
                Type = LifestyleType.Singleton;
                return _Parent;
            }
        }

        public ElementRegistration<TService> Instance(TService P_Instance)
        {
            Type = LifestyleType.Singleton;
            SingletonInstance = P_Instance;
            return _Parent;
        }

        public ElementRegistration<TService> Transient
        {
            get
            {
                Type = LifestyleType.Transient;
                return _Parent;
            }
        }

        public ElementRegistration<TService> PooledWithSize(int? P_MinSize, int? P_MaxSize)
        {
            Type = LifestyleType.Pooled;
            PoolSizeMax = P_MaxSize;
            PoolSizeMin = P_MinSize;
            return _Parent;
        }
    }
}