﻿using System;
using System.Linq.Expressions;
using System.Reflection;
using Loki.Utils;

namespace Loki.Engine.Registration
{
    public class Property<TService>
    {
        public PropertyInfo Key { get; internal set; }

        public object Value { get; internal set; }

        public static PropertyKey<TService> ForKey<TProperty>(Expression<Func<TService, TProperty>> P_Property)
        {
            Property<TService> L_New = new Property<TService>();
            L_New.Key = ExpressionHelper.GetProperty(P_Property);
            return new PropertyKey<TService>(L_New);
        }

        public static PropertyKey<object> ForKey(PropertyInfo P_Property)
        {
            Property<object> L_New = new Property<object>();
            L_New.Key = P_Property;
            return new PropertyKey<object>(L_New);
        }
    }
}