﻿using Loki.UI;
using Loki.Utils;

namespace Loki.Engine
{
    public interface IEngine
    {
        void Initialize();

        TDataModel GetDataModel<TDataModel>() where TDataModel : class, IObjectCreator;

        TApplicationModel GetApplicationModel<TApplicationModel>() where TApplicationModel : class, IObjectCreator;

        TViewModel GetViewModel<TViewModel>() where TViewModel : class, IViewModel;

        void DefineDataModel(ObjectModel P_Model);

        void DefineApplicationModel(ObjectModel P_Model);

        void DefineUIModel(ObjectModel P_Model);

        IObjectContext CreateContext(string P_ContextName);
    }
}