﻿using Loki.Utils;

namespace Loki.Model
{
    public abstract class SubEntity<TParentEntity, TModel, TDataModel> : TrackedObject
        where TParentEntity : Entity<TModel, TDataModel>
        where TModel : class, IObjectCreator
        where TDataModel : class, IObjectCreator
    {
        public TParentEntity Parent
        {
            get;
            private set;
        }

        public SubEntity(TParentEntity P_Parent)
        {
            Parent = P_Parent;
        }
    }
}