﻿using System;
using Loki.Model;

namespace Loki.UI
{
    /// <summary>
    /// Interface for container view models.
    /// </summary>
    public interface IContainerViewModel : IViewModel
    {
        /// <summary>
        /// Gets the sub models.
        /// </summary>
        /// <value>The sub models.</value>
        ILokiEnumerable<IViewModel> SubModels { get; }

        event EventHandler<ViewModelEventArgs> SubModelActivated;
    }
}