﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using Loki.Commands;
using Loki.Utils;

namespace Loki.UI
{
    public interface IViewModel : INotifyPropertyChanged, ICentralizedChangeTracking, ISupportInitializeNotification, ISupportInitialize, IDataErrorInfo
    {
        ICommand Activate { get; }

        ICommand Desactivate { get; }

        bool IsActive { get; }

        event EventHandler Activated;

        event EventHandler Desactivated;

        ICommand Close { get; }

        string DisplayName { get; set; }

        bool IsValid { get; set; }

        IModalViewModel ModalViewModel { get; }

        void Initialize();

        void LoadData();

        void StartInteraction();

        void DoCleanup();

        event EventHandler Start;

        event EventHandler Load;

        event EventHandler Init;

        event EventHandler Clean;

        string Status { get; set; }

        bool ValidationEnabled { get; }

        bool Validate(ValidationMode P_Mode);

        void EndInit(bool P_State);

        IDictionary<string, IValidator> Validators { get; }
    }
}