﻿namespace Loki.Events
{
    /// <summary>
    /// Weak callback base interface.
    /// </summary>
    public interface IWeakCallback
    {
        /// <summary>
        /// Gets the listener reference.
        /// </summary>
        object Listener { get; }
    }

    /// <summary>
    /// Weak event callback parametrized interface.
    /// </summary>
    /// <typeparam name="TArgs">The type of the args.</typeparam>
    public interface IWeakEventCallback<TArgs> : IWeakCallback
    {
        /// <summary>
        /// Invokes the callback with the specified parameters.
        /// </summary>
        /// <param name="P_Sender">The sender.</param>
        /// <param name="P_Args">The args.</param>
        bool Invoke(object P_Sender, TArgs P_Args);
    }
}
