﻿using System;
using System.ComponentModel;

namespace Loki.Utils
{
    /// <summary>
    /// Common interface for centralized state change.
    /// </summary>
    public interface ICentralizedChangeTracking : INotifyPropertyChanged, ISupportInitialize, IChangeTracking
    {
        /// <summary>
        /// Occurs when internal state changed.
        /// </summary>
        event EventHandler StateChanged;
    }
}
