﻿namespace Loki.Utils
{
    public interface IObjectCreator
    {
        /// <summary>
        /// Creates a new instance of the specified type.
        /// </summary>
        /// <typeparam name="T">Desired type.</typeparam>
        T Create<T>() where T : class;

        /// <summary>
        /// Gets a singleton of the specified type.
        /// </summary>
        /// <typeparam name="T">Desired type.</typeparam>
        T Get<T>() where T : class;

        /// <summary>
        /// Creates a new instance of the specified type.
        /// </summary>
        /// <typeparam name="T">Desired type.</typeparam>
        /// <param name="P_Name">Specific name.</param>
        T Create<T>(string P_Name) where T : class;

        /// <summary>
        /// Gets a singleton of the specified type.
        /// </summary>
        /// <typeparam name="T">Desired type.</typeparam>
        /// <param name="P_Name">Specific name.</param>
        T Get<T>(string P_Name) where T : class;
    }
}