﻿using System;
using System.ComponentModel;
using System.Linq.Expressions;

namespace Loki.Utils
{
    /// <summary>
    /// A small helper class that has a method to help create
    /// PropertyChangedEventArgs when using the INotifyPropertyChanged
    /// interface.
    /// </summary>
    public static class ObservableHelper
    {
        #region Public Methods
        /// <summary>
        /// Creates PropertyChangedEventArgs.
        /// </summary>
        /// <typeparam name="T">Type used to get the property name.</typeparam>
        /// <param name="P_PropertyExpression">Expression to make PropertyChangedEventArgs out of.</param>
        /// <returns>PropertyChangedEventArgs for the specified property.</returns>
        public static PropertyChangedEventArgs CreateChangedArgs<T>(Expression<Func<T, object>> P_PropertyExpression)
        {
            return new PropertyChangedEventArgs(ExpressionHelper.GetProperty(P_PropertyExpression).Name);
        }

        /// <summary>
        /// Creates the PropertyChangingEventArgs.
        /// </summary>
        /// <typeparam name="T">Type used to get the property name.</typeparam>
        /// <param name="P_PropertyExpression">Expression to make PropertyChangingEventArgs out of.</param>
        /// <returns>PropertyChangingEventArgs for the specified property.</returns>
        public static PropertyChangingEventArgs CreateChangingArgs<T>(Expression<Func<T, object>> P_PropertyExpression)
        {
            return new PropertyChangingEventArgs(ExpressionHelper.GetProperty(P_PropertyExpression).Name);
        }
        #endregion
    }
}
