﻿using System.ComponentModel.Composition;
using System.IO;
using log4net.Config;
using Loki.Utils;

namespace Loki.Log4Net
{
    [Export(typeof(ILogger))]
    [ExportMetadata("Type", "Log4Net")]
    public class Log4NetLogger : ILogger
    {
        public void Configure()
        {
            XmlConfigurator.Configure();
        }

        public void Configure(string P_ConfigurationFile)
        {
            XmlConfigurator.Configure(new FileInfo(P_ConfigurationFile));
        }

        public void Configure(Stream P_ConfigurationStream)
        {
            XmlConfigurator.Configure(P_ConfigurationStream);
        }

        public ILog GetLog(string P_LogName)
        {
            return new Log4NetLog(P_LogName);
        }
    }
}