﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Loki.UI.Win
{
    public static class ConverterHelper
    {
        private static IValueConverter _FormName = new FormNameConverter();
        public static IValueConverter FormName
        {
            get { return _FormName; }
        }

        public static IValueConverter EnumString<T>(T P_DefaultValue = default(T))
        {
            return new EnumStringValueConverter<T>(P_DefaultValue);
        }

        public static IMultiValueConverter StringFormat(string P_FormatString)
        {
            return new StringFormatConverter(P_FormatString);
        }

        public static IMultiValueConverter FormattedFormName()
        {
            return new FormattedFormNameConverter();
        }

        private static IValueConverter _HandleToIndex = new HandleToIndexConverter();
        public static IValueConverter HandleToIndex
        {
            get { return _HandleToIndex; }
        }

        private static IValueConverter _HasValue = new HasValueConverter();
        public static IValueConverter HasValue
        {
            get { return _HasValue; }
        }
    }
}
