﻿using System.Diagnostics;
using System.IO;
using System.Windows.Interactivity;
using System.Windows.Media;
using DevExpress.Xpf.Bars;
using DevExpress.Xpf.Grid;

namespace Loki.UI.Wpf
{
    public class GridExportBehaviour : Behavior<GridControl>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            TableView L_View = AssociatedObject.View as TableView;

            L_View.ShowGridMenu += L_View_ShowGridMenu;
        }

        private void L_View_ShowGridMenu(object sender, GridMenuEventArgs e)
        {
            BarItemLinkSeparator L_Separator = new BarItemLinkSeparator();

            BarButtonItem L_Export = new BarButtonItem();
            L_Export.Name = "Export";
            L_Export.Content = "Export menu";
            L_Export.Glyph = AssociatedObject.FindResource("MNI_excel") as ImageSource;
            L_Export.BarItemDisplayMode = BarItemDisplayMode.ContentAndGlyph;
            L_Export.ItemClick += L_Export_ItemClick;

            e.Customizations.Add(L_Separator);
            e.Customizations.Add(L_Export);
        }

        private void L_Export_ItemClick(object sender, ItemClickEventArgs e)
        {
            TableView L_View = AssociatedObject.View as TableView;
            string L_FileName = Path.GetTempFileName() + ".xlsx";
            L_View.ExportToXlsx(L_FileName);
            Process.Start(L_FileName);
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();

            TableView L_View = AssociatedObject.View as TableView;
            L_View.ShowGridMenu -= L_View_ShowGridMenu;
        }
    }
}