﻿using System.Windows;
using System.Windows.Interactivity;
using DevExpress.Xpf.Grid;

namespace Loki.UI.Wpf
{
    public class IsChangedBehavior : Behavior<GridControl>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.Loaded += AssociatedObject_Loaded;
        }

        private void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            TableView L_View = AssociatedObject.View as TableView;
            if (L_View != null && L_View.AllowEditing)
            {
                L_View.RowStyle = AssociatedObject.FindResource("IsChangedBackgroundStyle") as Style;
            }
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
            AssociatedObject.Loaded -= AssociatedObject_Loaded;
        }
    }
}