﻿using System;
using System.Globalization;
using System.Windows.Data;
using Loki.Utils;

namespace Loki.UI.Wpf
{
    public class CommandToTileConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            bool first;
            LokiCollection<TileViewModel> flatCollection = new LokiCollection<TileViewModel>();
            LokiCollection<CommandGroupViewModel> Groups = value as LokiCollection<CommandGroupViewModel>;
            if (Groups != null)
            {
                foreach (CommandGroupViewModel group in Groups)
                {
                    first = true;
                    foreach (var tile in group.Commands)
                    {
                        if (first)
                            flatCollection.Add(new TileViewModel() { Header = tile.Name, Command = tile.Command, GroupHeader = group.Name, IsFlowBreak = true });
                        else
                            flatCollection.Add(new TileViewModel() { Header = tile.Name, Command = tile.Command, });
                        first = false;
                    }
                }
            }

            return flatCollection;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }
    }
}