﻿using System;
using System.Windows;
using DevExpress.Xpf.Core;
using Loki.UI.Wpf.Resources;

namespace Loki.UI.Wpf
{
    public static class MessageBoxes
    {
        public static bool Confirm(string P_FormatString, params object[] P_FormatParams)
        {
            return DXMessageBox.Show(string.Format(P_FormatString, P_FormatParams), string.Empty, MessageBoxButton.OKCancel, MessageBoxImage.Question) == MessageBoxResult.OK;
        }

        public static void Message(string P_FormatString, params object[] P_FormatParams)
        {
            DXMessageBox.Show(string.Format(P_FormatString, P_FormatParams), UIValues.MessageBox_Info, MessageBoxButton.OK, MessageBoxImage.Information);
        }

        public static void Warning(string P_FormatString, params object[] P_FormatParams)
        {
            DXMessageBox.Show(string.Format(P_FormatString, P_FormatParams), UIValues.MessageBox_Warning, MessageBoxButton.OK, MessageBoxImage.Warning);
        }
    }
}
