﻿using System.Collections.Generic;
using Loki.Utils;
using Luna.Connectors;
using Luna.Data.Budget;
using Luna.Data.Configuration;
using Luna.Data.Contacts;

namespace Luna.Data
{
    public interface IDataContext : IObjectCreator
    {
        IContactProvider Contacts { get; }

        IBudgetProvider Budget { get; }

        IConfigurationProvider Configuration { get; }

        IDictionary<ConnectorType, IConnector> Connectors { get; }
    }
}