﻿using System.Collections.Generic;
using Loki.Engine;

namespace Luna.Data.Contacts
{
    public interface IContactProvider : IDataProvider
    {
        IEnumerable<IContactData> ContactGetAll();

        IContactData ContactGet(IReferenceData P_ContactID);

        void ContactSave(IContactData P_Contact);

        void ContactDelete(IReferenceData P_Contact);

        void ContactSave(IEnumerable<IContactData> P_Contacts);

        void ContactDelete(IEnumerable<IContactData> P_Contact);

        IEnumerable<IAccountData> AccountGetAll();

        IAccountData AccountGet(IReferenceData P_AccountID);

        void AccountSave(IAccountData P_Account);

        void AccountDelete(IReferenceData P_AccountID);

        void AccountSave(IEnumerable<IAccountData> P_Accounts);

        void AccountDelete(IEnumerable<IAccountData> P_Accounts);

        IEnumerable<ICategoryData> CategoryGetAll();

        ICategoryData CategoryGet(IReferenceData P_CategoryID);

        void CategorySave(ICategoryData P_Category);

        void CategoryDelete(IReferenceData P_CategoryID);
    }
}