﻿using Loki.Data;

namespace Luna.Data
{
    /// <summary>
    /// Interface for datamanagers.
    /// </summary>
    public interface IDatabaseManager
    {
        /// <summary>
        /// Gets or sets the current database connector.
        /// </summary>
        /// <value>
        /// The current database connector.
        /// </value>
        IDatabaseAdapter Current { get; set; }

        /// <summary>
        /// Creates a new database with the specified name.
        /// </summary>
        /// <param name="P_DatabaseName">Name of the database.</param>
        void Create(string P_DatabaseName);

        /// <summary>
        /// Opens the specified database name.
        /// </summary>
        /// <param name="P_DatabaseName">Name of the  database.</param>
        void Open(string P_DatabaseName);

        /// <summary>
        /// Saves the current database with the specified name.
        /// </summary>
        /// <param name="P_DatabaseName">Name of the database.</param>
        void SaveAs(string P_DatabaseName);
    }
}
