﻿using System;
using Loki.Data;
using Loki.Engine;
using Loki.Model;
using Luna.Data;

namespace Luna.Model
{
    public abstract class LunaService : ApplicationService<IApplicationModel, IDataContext>
    {
        protected void Save<TInterface, TEntity, TEntityData>(TInterface P_Entity, Action<TEntityData> P_DataSave, EntityContainer<TEntity, Guid> P_Store)
            where TEntity : LunaEntity<TEntityData>, TInterface, ILunaEntity
            where TEntityData : class, IDataEntity<Guid>
        {
            TEntity L_Entity = P_Entity as TEntity;
            if (L_Entity != null && L_Entity.IsChanged)
            {
                P_DataSave(L_Entity.Data);

                P_Store.Register(L_Entity);
            }
        }

        protected void Delete<TInterface, TEntity, TEntityData>(TInterface P_Entity, Action<Guid> P_DataDelete, EntityContainer<TEntity, Guid> P_Store)
            where TEntity : LunaEntity<TEntityData>, TInterface, ILunaEntity
            where TEntityData : class, IDataEntity<Guid>
        {
            TEntity L_Entity = P_Entity as TEntity;
            if (L_Entity != null)
            {
                P_DataDelete(L_Entity.Data.PK);

                P_Store.Remove(L_Entity);
            }
        }

        protected void Delete<TInterface, TEntity, TEntityData>(TInterface P_Entity, Action<TEntityData> P_DataDelete, EntityContainer<TEntity, Guid> P_Store)
            where TEntity : LunaEntity<TEntityData>, TInterface, ILunaReferenceEntity
            where TEntityData : class, IDataEntity<Guid>
        {
            TEntity L_Entity = P_Entity as TEntity;
            if (L_Entity != null)
            {
                P_DataDelete(L_Entity.Data);

                P_Store.Remove(L_Entity);
            }
        }
    }
}