﻿using Loki.Engine;
using Loki.Engine.Registration;
using Luna.Data.Contacts;

namespace Luna.Connectors.Google
{
    public class ConnectorInstaller : LokiContextInstaller
    {
        public override void Install(IObjectContext P_Context)
        {
            string L_GoogleName = ConnectorType.Google.ToString();

            P_Context.Register(Element.For<GoogleSettingsManager>());

            P_Context.Register(Element.For<IContactProvider>().Named(L_GoogleName).ImplementedBy<GoogleContactProvider>());

            P_Context.Register(Element.For<IConnector>()
                .Named(L_GoogleName)
                .ImplementedBy<GoogleConnector>()
                .Overrides(Property<IConnector>.ForKey(x => x.Contacts).Value(L_GoogleName)));
        }

        private static ConnectorInstaller _Google = new ConnectorInstaller();

        public static ConnectorInstaller Google
        {
            get { return _Google; }
        }
    }
}