﻿using System;
using System.Collections.Generic;
using System.Linq;
using Google.Contacts;
using Google.GData.Client;
using Luna.Data;
using Luna.Data.Contacts;

namespace Luna.Connectors.Google
{
    public class GoogleContactProvider : LunaDataProvider, IContactProvider
    {
        public GoogleSettingsManager Manager { get; set; }

        public GoogleContactProvider()
        {
            // service.setUserCredentials("leilalepole@gmail.com", "lepole93");
            // service.setUserCredentials("anolige@gmail.com", "musicislife5632");
        }

        public string Test(IGoogleSettings P_Data)
        {
            try
            {
                ContactsRequest L_Request = new ContactsRequest(Manager.TestQuery(P_Data));
                Feed<Contact> L_Feed = L_Request.GetContacts();
                L_Feed.Entries.Count();
                return string.Empty;
            }
            catch (Exception L_Return)
            {
                Log.Error(L_Return.Message, L_Return);
                return L_Return.Message;
            }
        }

        private ICategoryData CreateGroup(Group P_Entry)
        {
            var L_Return = new CategoryData();
            L_Return.Name = P_Entry.Title;
            L_Return.Name = P_Entry.Id.Substring(P_Entry.Id.LastIndexOf("/") + 1);
            L_Return.LastUpdate = P_Entry.Updated;
            return L_Return;
        }

        private IContactData Create(Contact P_Entry)
        {
            var L_Return = new ContactData();
            if (P_Entry.Name != null)
            {
                L_Return.Name = P_Entry.Name.FamilyName;
                L_Return.GivenName = P_Entry.Name.GivenName;
            }

            if (P_Entry.PrimaryEmail != null)
            {
                L_Return.Mail = P_Entry.PrimaryEmail.Address;
            }
            else if (P_Entry.Emails.Count() > 0)
            {
                L_Return.Mail = P_Entry.Emails[0].Address;
            }

            var L_PhoneNumber = P_Entry.Phonenumbers.FirstOrDefault();
            if (L_PhoneNumber != null)
            {
                L_Return.PhoneNumber = L_PhoneNumber.Value;
            }

            return L_Return;
        }

        public IEnumerable<IContactData> ContactGetAll()
        {
            ContactsRequest L_Request = new ContactsRequest(Manager.Settings);
            Feed<Contact> L_Feed = L_Request.GetContacts();
            foreach (Contact L_Entry in L_Feed.Entries)
            {
                yield return Create(L_Entry);
            }
        }

        public IContactData ContactGet(IReferenceData P_ContactID)
        {
            throw new NotImplementedException();
        }

        public void ContactSave(IContactData P_Contact)
        {
            throw new NotImplementedException();
        }

        public void ContactDelete(IReferenceData P_Contact)
        {
            throw new NotImplementedException();
        }

        public void ContactSave(IEnumerable<IContactData> P_Contacts)
        {
            throw new NotImplementedException();
        }

        public void ContactDelete(IEnumerable<IContactData> P_Contact)
        {
            throw new NotImplementedException();
        }

        public IEnumerable<IAccountData> AccountGetAll()
        {
            throw new NotImplementedException();
        }

        public IAccountData AccountGet(IReferenceData P_AccountID)
        {
            throw new NotImplementedException();
        }

        public void AccountSave(IAccountData P_Account)
        {
            throw new NotImplementedException();
        }

        public void AccountDelete(IReferenceData P_AccountID)
        {
            throw new NotImplementedException();
        }

        public void AccountSave(IEnumerable<IAccountData> P_Accounts)
        {
            throw new NotImplementedException();
        }

        public void AccountDelete(IEnumerable<IAccountData> P_Accounts)
        {
            throw new NotImplementedException();
        }

        public IEnumerable<ICategoryData> CategoryGetAll()
        {
            ContactsRequest L_Request = new ContactsRequest(Manager.Settings);
            Feed<Group> L_Feed = L_Request.GetGroups();
            foreach (Group L_Entry in L_Feed.Entries.Where(x => string.IsNullOrEmpty(x.SystemGroup)))
            {
                yield return CreateGroup(L_Entry);
            }
        }

        public ICategoryData CategoryGet(IReferenceData P_CategoryID)
        {
            throw new NotImplementedException();
        }

        public void CategorySave(ICategoryData P_Category)
        {
            throw new NotImplementedException();
        }

        public void CategoryDelete(IReferenceData P_CategoryID)
        {
            throw new NotImplementedException();
        }
    }
}