﻿using Google.GData.Client;
using Loki.Utils;

namespace Luna.Connectors.Google
{
    public class GoogleSettingsManager : LokiObject
    {
        private const string APPLICATION_NAME = "Luna";

        public void Configure(IGoogleSettings P_Data)
        {
            _Settings = new RequestSettings(APPLICATION_NAME, P_Data.Login, P_Data.Password);
        }

        private RequestSettings _Settings;

        public RequestSettings Settings
        {
            get
            {
                if (_Settings == null)
                {
                    throw BuildError<LokiException>("Connector is not configured");
                }
                else
                {
                    return _Settings;
                }
            }
        }

        public RequestSettings TestQuery(IGoogleSettings P_Data)
        {
            return new RequestSettings(APPLICATION_NAME, P_Data.Login, P_Data.Password);
        }
    }
}