﻿using Loki.Engine;
using Loki.Engine.Registration;
using Luna.Data.Contacts;

namespace Luna.Connectors.ZohoCRM
{
    public class ConnectorInstaller : LokiContextInstaller
    {
        public override void Install(IObjectContext P_Context)
        {
            string L_ZohoName = ConnectorType.ZohoCRM.ToString();

            P_Context.Register(Element.For<ZohoCRMSettingsManager>());

            P_Context.Register(Element.For<IContactProvider>().Named(L_ZohoName).ImplementedBy<ZohoCRMContactProvider>());

            P_Context.Register(Element.For<IConnector>()
                .Named(L_ZohoName)
                .ImplementedBy<ZohoCRMConnector>()
                .Overrides(Property<IConnector>.ForKey(x => x.Contacts).Value(L_ZohoName)));
        }

        private static ConnectorInstaller _Zoho = new ConnectorInstaller();

        public static ConnectorInstaller Zoho
        {
            get { return _Zoho; }
        }
    }
}