﻿using System;
using Loki.Utils;
using Luna.UI.Resources;

namespace Luna.UI.Contacts
{
    public class CategoryListViewModel : LunaViewModel
    {
        public LokiCollection<DisplayableCategory> Categories { get; private set; }

        public CategoryListViewModel()
        {
            Categories = CreateCollection<DisplayableCategory>();

            DisplayName = FormNames.CATEGORY_LIST;

            Load += CategoryListViewModel_Load;
        }

        private void CategoryListViewModel_Load(object P_Sender, EventArgs e)
        {
            Categories.Synchronize(
                ApplicationModel.Contacts.Categories,
                (data, display) => display.LoadFrom(data),
                (data, display) => data.ID == display.ID,
                display => display.Name);
        }
    }
}