﻿using System.ComponentModel;
using Loki.Utils;
using Luna.Model.Contacts;

namespace Luna.UI.Contacts
{
    public class DisplayableCategory : LunaDisplayable
    {
        #region Name

        private static PropertyChangedEventArgs _NameChangedArgs = ObservableHelper.CreateChangedArgs<DisplayableCategory>(x => x.Name);

        private static PropertyChangingEventArgs _NameChangingArgs = ObservableHelper.CreateChangingArgs<DisplayableCategory>(x => x.Name);

        private string _Name;

        public string Name
        {
            get
            {
                return _Name;
            }

            set
            {
                if (value != _Name)
                {
                    NotifyChanging(_NameChangingArgs);
                    _Name = value;
                    NotifyChangedAndDirty(_NameChangedArgs);
                }
            }
        }

        #endregion Name

        #region Description

        private static PropertyChangedEventArgs _DescriptionChangedArgs = ObservableHelper.CreateChangedArgs<DisplayableCategory>(x => x.Description);

        private static PropertyChangingEventArgs _DescriptionChangingArgs = ObservableHelper.CreateChangingArgs<DisplayableCategory>(x => x.Description);

        private string _Description;

        public string Description
        {
            get
            {
                return _Description;
            }

            set
            {
                if (value != _Description)
                {
                    NotifyChanging(_DescriptionChangingArgs);
                    _Description = value;
                    NotifyChanged(_DescriptionChangedArgs);
                }
            }
        }

        #endregion Description

        public ICategory Category
        {
            get
            {
                return ApplicationModel.Contacts.Categories[ID];
            }
        }

        public void LoadFrom(ICategory P_Source)
        {
            ID = P_Source.ID;
            Name = P_Source.Name;
            Description = P_Source.Description;
        }
    }
}