﻿using Loki.Commands;
using Luna.UI.Contacts;

namespace Luna.UI
{
    public class OpenDocumentsViewModel : LunaContainerViewModel
    {
        public OpenDocumentsViewModel()
        {
            Init += OpenDocumentsViewModel_Init;
        }

        private void OpenDocumentsViewModel_Init(object sender, System.EventArgs e)
        {
            Commands.Handle(NavigationCommands.CONTACTS, Navigation_Contacts_Execute);
            Commands.Handle(NavigationCommands.ACCOUNTS, Navigation_Accounts_Execute);
            Commands.Handle(NavigationCommands.CATEGORIES, Navigation_Categories_Execute);
        }

        private void Navigation_Contacts_Execute(object P_Sender, CommandEventArgs e)
        {
            ActivateOrAdd<ContactListViewModel>();
        }

        private void Navigation_Accounts_Execute(object P_Sender, CommandEventArgs e)
        {
            ActivateOrAdd<AccountListViewModel>();
        }

        private void Navigation_Categories_Execute(object P_Sender, CommandEventArgs e)
        {
            ActivateOrAdd<CategoryListViewModel>();
        }
    }
}