﻿using System;
using System.Reflection;
using Loki.Utils;
using Luna.Data.Test;
using NUnit.Framework;

[SetUpFixture]
public class TestSetup
{
    private TestDataModel _Model = new TestDataModel();

    [SetUp]
    public void Initialize()
    {
        // Initialize Data engine
        try
        {
            ToolKit.Logger.Configure(Assembly.GetExecutingAssembly().GetManifestResourceStream("Luna.Data.SqlCe.Test.log4net.config"));
            ToolKit.Logger.GetLogger("").Debug("test log");
            ToolKit.Engine.DefineDataModel(_Model);
            _Model.Initialize();
        }
        catch (Exception ex)
        {
            Console.Out.WriteLine(ex.Message);
        }
    }

    [TearDown]
    public void Clean()
    {
        _Model.Clean();
        ToolKit.Reset();
    }
}