﻿using System.IO;
using Loki.Engine;
using Luna.Connectors;
using Luna.Data.Configuration;
using Luna.Data.Contacts;
using Luna.Data.SqlCe;

namespace Luna.Data.Test
{
    public class TestDataModel : ObjectModel, IDataContext
    {
        private const string TEST_FILE = "testdatabase.sdf";

        protected override void InternalLoad()
        {
            base.InternalLoad();

            DatabaseInstaller.SqlCE.Install(InternalContext);

            DataInstallers.All.Install(InternalContext);

            var L_ConfigProvider = InternalContext.Resolve<IConfigurationProvider>();
            L_ConfigProvider.CreateNewStore(TEST_FILE);
        }

        public void Clean()
        {
            File.Delete(TEST_FILE);
        }

        public IContactProvider Contacts
        {
            get { throw new System.NotImplementedException(); }
        }

        public IConfigurationProvider Configuration
        {
            get { throw new System.NotImplementedException(); }
        }

        public System.Collections.Generic.IDictionary<ConnectorType, IConnector> Connectors
        {
            get { throw new System.NotImplementedException(); }
        }

        public Budget.IBudgetProvider Budget
        {
            get { throw new System.NotImplementedException(); }
        }
    }
}