﻿using Loki.Engine;
using Loki.Engine.Registration;
using Luna.Data.Contacts;

namespace Luna.Data
{
    public class AccountInstaller : LokiContextInstaller
    {
        private const string ACCOUNT_GET_ALL = "account_get_all";
        private const string ACCOUNT_GET = "account_get";
        private const string ACCOUNT_DELETE = "account_delete";
        private const string ACCOUNT_INSERT = "account_insert";
        private const string ACCOUNT_UPDATE = "account_update";

        private const string CATEGORY_GET_ALL = "contact_category_get_all";
        private const string CATEGORY_GET = "contact_category_get";
        private const string CATEGORY_DELETE = "contact_category_delete";
        private const string CATEGORY_INSERT = "contact_category_insert";
        private const string CATEGORY_UPDATE = "contact_category_update";

        public override void Install(IObjectContext P_Context)
        {
            P_Context.Register(Element.Entity<IAccountData, AccountData>());
            P_Context.Register(Element.Entity<ICategoryData, CategoryData>());

            P_Context.Register(Element.Service<IContactProvider, ContactProvider>());

            P_Context.Register(Element.Mapper<AccountDataMapper>(ACCOUNT_GET_ALL, ACCOUNT_GET, ACCOUNT_DELETE, ACCOUNT_INSERT, ACCOUNT_UPDATE));
            P_Context.Register(Element.Mapper<CategoryDataMapper>(CATEGORY_GET_ALL, CATEGORY_GET, CATEGORY_DELETE, CATEGORY_INSERT, CATEGORY_UPDATE));
        }
    }
}