﻿using Loki.Engine;
using Loki.Engine.Registration;
using Luna.Data.Budget;

namespace Luna.Data
{
    public class BudgetInstaller : LokiContextInstaller
    {
        private const string CATEGORY_GET_ALL = "budget_category_get_all";
        private const string CATEGORY_GET = "budget_category_get";
        private const string CATEGORY_DELETE = "budget_category_delete";
        private const string CATEGORY_INSERT = "budget_category_insert";
        private const string CATEGORY_UPDATE = "budget_category_update";

        public override void Install(IObjectContext P_Context)
        {
            P_Context.Register(Element.Entity<ICategoryData, CategoryData>());

            P_Context.Register(Element.Service<IBudgetProvider, BudgetProvider>());

            P_Context.Register(Element.Mapper<CategoryDataMapper>(CATEGORY_GET_ALL, CATEGORY_GET, CATEGORY_DELETE, CATEGORY_INSERT, CATEGORY_UPDATE));
        }
    }
}