﻿using Loki.Engine;
using Loki.Engine.Registration;
using Luna.Data.Configuration;

namespace Luna.Data
{
    public class ConfigurationInstaller : LokiContextInstaller
    {
        private const string CONNECTOR_GET_ALL = "connector_get_all";
        private const string CONNECTOR_GET = "connector_get";
        private const string CONNECTOR_DELETE = "connector_delete";
        private const string CONNECTOR_INSERT = "connector_insert";
        private const string CONNECTOR_UPDATE = "connector_update";

        public override void Install(IObjectContext P_Context)
        {
            P_Context.Register(Element.Entity<IConnectorData, ConnectorData>());

            P_Context.Register(Element.Service<IConfigurationProvider, ConfigurationProvider>());

            P_Context.Register(Element.Mapper<ConnectorDataMapper>(CONNECTOR_GET_ALL, CONNECTOR_GET, CONNECTOR_DELETE, CONNECTOR_INSERT, CONNECTOR_UPDATE));
        }
    }
}