﻿using Loki.Engine;

namespace Luna.Data
{
    public static class DataInstallers
    {
        private static AccountInstaller _Accounts = new AccountInstaller();

        private static ConfigurationInstaller _Configuration = new ConfigurationInstaller();

        private static CommonInstaller _Common = new CommonInstaller();

        private static BudgetInstaller _Budget = new BudgetInstaller();

        public static CommonInstaller Common
        {
            get
            {
                return _Common;
            }
        }

        public static AccountInstaller Accounts
        {
            get
            {
                return _Accounts;
            }
        }

        public static ConfigurationInstaller Configuration
        {
            get
            {
                return _Configuration;
            }
        }

        public static BudgetInstaller Budget
        {
            get
            {
                return _Budget;
            }
        }

        public static IContextInstaller All
        {
            get
            {
                return new LokiContextInstaller().Merge(Accounts, Configuration, Budget, Common);
            }
        }
    }
}