﻿using System.Data;
using Loki.Data;
using Luna.Connectors;

namespace Luna.Data.Configuration
{
    public class ConnectorDataMapper : LunaMapper<ConnectorData, IConnectorData>
    {
        private const string TYPE = "Type";
        private const string LOGIN = "Login";
        private const string PASSWORD = "Password";
        private const string PARAMS = "Params";

        protected override void LoadCoreData(IConnectorData P_Entity, IDataRecord P_Record)
        {
            P_Entity.Type = P_Record.GetEnum<ConnectorType>(TYPE);
            P_Entity.Login = P_Record.GetString(LOGIN);
            P_Entity.Password = P_Record.GetString(PASSWORD);
            P_Entity.Params = P_Record.GetString(PARAMS);
        }

        protected override void MapSaveParameters(IDatabaseCommand P_Command, IConnectorData P_Entity)
        {
            P_Command.AddParameter(TYPE, P_Entity.Type.ToString());
            P_Command.AddParameter(LOGIN, P_Entity.Login);
            P_Command.AddParameter(PASSWORD, P_Entity.Password);
            P_Command.AddParameter(PARAMS, P_Entity.Params);
            P_Command.AddParameter(IDParameterName, P_Entity.PK);
        }
    }
}