﻿using System.Data;
using Loki.Data;

namespace Luna.Data.Contacts
{
    public class AccountDataMapper : LunaEntityMapper<AccountData, IAccountData>
    {
        private const string CATEGORY_ID = "CategoryID";
        private const string NAME = "Name";
        private const string ADDRESS = "Address";
        private const string ZIPCODE = "Zipcode";
        private const string CITY = "City";
        private const string COUNTRY = "Country";
        private const string PHONE_NUMBER = "PhoneNumber";
        private const string URL = "Url";
        private const string MAIL = "Mail";
        private const string COMMENT = "Comment";

        protected override void LoadCoreData(IAccountData P_Entity, IDataRecord P_Record)
        {
            P_Entity.CategoryID = P_Record.GetNullableGuid(CATEGORY_ID);
            P_Entity.Name = P_Record.GetString(NAME);
            P_Entity.Address = P_Record.GetString(ADDRESS);
            P_Entity.Zipcode = P_Record.GetString(ZIPCODE);
            P_Entity.City = P_Record.GetString(CITY);
            P_Entity.Country = P_Record.GetString(COUNTRY);
            P_Entity.PhoneNumber = P_Record.GetString(PHONE_NUMBER);
            P_Entity.Url = P_Record.GetString(URL);
            P_Entity.Mail = P_Record.GetString(MAIL);
            P_Entity.Comment = P_Record.GetString(COMMENT);
        }

        protected override void MapSaveParameters(IDatabaseCommand P_Command, IAccountData P_Entity)
        {
            P_Command.AddParameter(CATEGORY_ID, P_Entity.CategoryID);
            P_Command.AddParameter(NAME, P_Entity.Name);
            P_Command.AddParameter(ADDRESS, P_Entity.Address);
            P_Command.AddParameter(ZIPCODE, P_Entity.Zipcode);
            P_Command.AddParameter(CITY, P_Entity.City);
            P_Command.AddParameter(COUNTRY, P_Entity.Country);
            P_Command.AddParameter(PHONE_NUMBER, P_Entity.PhoneNumber);
            P_Command.AddParameter(URL, P_Entity.Url);
            P_Command.AddParameter(MAIL, P_Entity.Mail);
            P_Command.AddParameter(COMMENT, P_Entity.Comment);
            P_Command.AddParameter(IDParameterName, P_Entity.PK);
        }
    }
}