﻿using System.Data;
using Loki.Data;

namespace Luna.Data.Contacts
{
    public class CategoryDataMapper : LunaEntityMapper<CategoryData, ICategoryData>
    {
        private const string NAME = "Name";
        private const string DESCRIPTION = "Description";

        protected override void LoadCoreData(ICategoryData P_Entity, IDataRecord P_Record)
        {
            P_Entity.Name = P_Record.GetString(NAME);
            P_Entity.Description = P_Record.GetString(DESCRIPTION);
        }

        protected override void MapSaveParameters(IDatabaseCommand P_Command, ICategoryData P_Entity)
        {
            P_Command.AddParameter(NAME, P_Entity.Name);
            P_Command.AddParameter(DESCRIPTION, P_Entity.Description);
            P_Command.AddParameter(IDParameterName, P_Entity.PK);
        }
    }
}