﻿using System.Data;
using Loki.Data;

namespace Luna.Data.Contacts
{
    public class ContactDataMapper : LunaEntityMapper<ContactData, IContactData>
    {
        private const string ACCOUNT_ID = "AccountID";
        private const string NAME = "Name";
        private const string GIVEN_NAME = "GivenName";
        private const string TITLE = "Title";
        private const string FUNCTION = "Function";
        private const string MOBILE_NUMBER = "MobileNumber";
        private const string PHONE_NUMBER = "PhoneNumber";
        private const string MAIL = "Mail";
        private const string ADDRESS = "Address";
        private const string ZIPCODE = "Zipcode";
        private const string CITY = "City";
        private const string COUNTRY = "Country";
        private const string USE_COMPANY_INFOS = "UseCompanyInfos";

        protected override void LoadCoreData(IContactData P_Entity, IDataRecord P_Record)
        {
            P_Entity.AccountID = P_Record.GetGuid(ACCOUNT_ID);
            P_Entity.Name = P_Record.GetString(NAME);
            P_Entity.GivenName = P_Record.GetString(GIVEN_NAME);
            P_Entity.Title = P_Record.GetString(TITLE);
            P_Entity.Function = P_Record.GetString(FUNCTION);
            P_Entity.MobileNumber = P_Record.GetString(MOBILE_NUMBER);
            P_Entity.PhoneNumber = P_Record.GetString(PHONE_NUMBER);
            P_Entity.Mail = P_Record.GetString(MAIL);
            P_Entity.Address = P_Record.GetString(ADDRESS);
            P_Entity.Zipcode = P_Record.GetString(ZIPCODE);
            P_Entity.City = P_Record.GetString(CITY);
            P_Entity.Country = P_Record.GetString(COUNTRY);
            P_Entity.UseCompanyInfos = P_Record.GetBoolean(USE_COMPANY_INFOS);
        }

        protected override void MapSaveParameters(IDatabaseCommand P_Command, IContactData P_Entity)
        {
            P_Command.AddParameter(ACCOUNT_ID, P_Entity.AccountID);
            P_Command.AddParameter(NAME, P_Entity.Name);
            P_Command.AddParameter(GIVEN_NAME, P_Entity.GivenName);
            P_Command.AddParameter(TITLE, P_Entity.Title);
            P_Command.AddParameter(FUNCTION, P_Entity.Function);
            P_Command.AddParameter(MOBILE_NUMBER, P_Entity.MobileNumber);
            P_Command.AddParameter(PHONE_NUMBER, P_Entity.PhoneNumber);
            P_Command.AddParameter(MAIL, P_Entity.Mail);
            P_Command.AddParameter(ADDRESS, P_Entity.Address);
            P_Command.AddParameter(ZIPCODE, P_Entity.Zipcode);
            P_Command.AddParameter(CITY, P_Entity.City);
            P_Command.AddParameter(COUNTRY, P_Entity.Country);
            P_Command.AddParameter(USE_COMPANY_INFOS, P_Entity.UseCompanyInfos);
            P_Command.AddParameter(IDParameterName, P_Entity.PK);
        }
    }
}