﻿using System;
using System.Data;
using Loki.Data;

namespace Luna.Data
{
    public abstract class LunaEntityMapper<TDataEntity, TDataInterface> : LunaMapper<TDataEntity, TDataInterface>
        where TDataInterface : IDataEntity<Guid>, IReferenceData
        where TDataEntity : TDataInterface
    {
        public ReferenceDataMapper<TDataEntity> ReferenceMapper { get; set; }

        protected LunaEntityMapper()
            : base()
        {
        }

        protected override void LoadSubObjects(TDataInterface P_Entity, IDataRecord P_Record)
        {
            ReferenceMapper.LoadFromDataRecord(P_Entity, P_Record);
        }

        public override void Save(IDbTransaction P_Transaction, TDataInterface P_Entity)
        {
            bool L_Persisted = P_Entity.AlreadyPersisted;
            base.Save(P_Transaction, P_Entity);
            P_Entity.AlreadyPersisted = L_Persisted;
            ReferenceMapper.Save(P_Transaction, P_Entity);
        }

        public override void Delete(IDbTransaction P_Transaction, Guid P_EntityKey)
        {
            base.Delete(P_Transaction, P_EntityKey);
            ReferenceMapper.Delete(P_Transaction, P_EntityKey);
        }
    }
}