﻿using System;
using System.Collections.Generic;

namespace Luna.Data.Budget
{
    public class BudgetProvider : LunaDataProvider, IBudgetProvider
    {
        public CategoryDataMapper CategoryMapper { get; set; }

        public IEnumerable<ICategoryData> CategoryGetAll()
        {
            return WrapperTransactional(T => CategoryMapper.GetAll(T));
        }

        public ICategoryData CategoryGet(Guid P_CategoryID)
        {
            return WrapperTransactional(T => CategoryMapper.Get(T, P_CategoryID));
        }

        public void CategorySave(ICategoryData P_Category)
        {
            WrapperTransactional(T =>
            {
                CategoryMapper.Save(T, P_Category);
            });
        }

        public void CategoryDelete(Guid P_CategoryID)
        {
            WrapperTransactional(T => CategoryMapper.Delete(T, P_CategoryID));
        }
    }
}