﻿using System;
using System.Linq;
using Loki.Engine;
using Loki.Model;
using Luna.Data;

namespace Luna.Model.Budget
{
    internal class CacheConfiguration : CacheConfiguration<IDataContext>
    {
        public static readonly ContainerConfiguration<Category, Guid> CATEGORIES = new ContainerConfiguration<Category, Guid>()
        {
            FullLoader = () => DataContext.Budget.CategoryGetAll().Select(x => new Category(x)),
            PrimaryKey = new UniqueKeyConfiguration<Category, Guid>()
            {
                Indexer = x => x.ID,
                Loader = x => { var L_Return = DataContext.Budget.CategoryGet(x); return L_Return != null ? new Category(L_Return) : null; }
            }
        };
    }
}