﻿using System;
using Loki.Model;
using Luna.Data.Budget;

namespace Luna.Model.Budget
{
    public class LunaBudgetService : LunaService, IBudgetService
    {
        public void Reset()
        {
            _Categories.Reset();
        }

        public LunaBudgetService()
        {
            _Categories = CreateContainer<Category, Guid>(CacheConfiguration.CATEGORIES);
        }

        private EntityContainer<Category, Guid> _Categories;

        public IIndexedEnumerable<ICategory, Guid> Categories
        {
            get { return _Categories; }
        }

        public void Save(IEditableCategory P_Category)
        {
            Save<IEditableCategory, Category, ICategoryData>(P_Category, DataContext.Budget.CategorySave, _Categories);
        }

        public void Delete(IEditableCategory P_Category)
        {
            Delete<IEditableCategory, Category, ICategoryData>(P_Category, DataContext.Budget.CategoryDelete, _Categories);
        }
    }
}