﻿using System.ComponentModel;
using Loki.Utils;

namespace Luna.Model.Configuration
{
    internal class DatabaseDescriptor : TrackedObject, IDatabaseDescriptor
    {
        #region  CurrentFile
        private static PropertyChangedEventArgs _CurrentFileChangedArgs = ObservableHelper.CreateChangedArgs<DatabaseDescriptor>(x => x.CurrentFile);

        private static PropertyChangingEventArgs _CurrentFileChangingArgs = ObservableHelper.CreateChangingArgs<DatabaseDescriptor>(x => x.CurrentFile);

        private string _CurrentFile;

        public string CurrentFile
        {
            get
            {
                return _CurrentFile;
            }

            set
            {
                if (value != _CurrentFile)
                {
                    NotifyChanging(_CurrentFileChangingArgs);
                    _CurrentFile = value;
                    NotifyChanged(_CurrentFileChangedArgs);
                }
            }
        }
        #endregion
    }
}
