﻿using Loki.Engine;
using Loki.Engine.Registration;

namespace Luna.Model.Contacts
{
    public class ServiceInstaller : LokiContextInstaller
    {
        public override void Install(IObjectContext P_Context)
        {
            P_Context.Register(Element.Entity<IContact, Contact>());
            P_Context.Register(Element.Entity<IAccount, Account>());
            P_Context.Register(Element.Entity<IEditableCategory, Category>());

            P_Context.Register(Element.Service<IContactService, LunaContactService>());
        }

        private static ServiceInstaller _Contacts = new ServiceInstaller();

        public static ServiceInstaller Contacts
        {
            get
            {
                return _Contacts;
            }
        }
    }
}