﻿using System.ComponentModel;
using Loki.Utils;
using Luna.Data.Contacts;

namespace Luna.Model.Contacts
{
    internal class Contact : LunaEntity<IContactData>, IContact
    {
        #region  FamilyName
        private static PropertyChangedEventArgs _FamilyNameChangedArgs = ObservableHelper.CreateChangedArgs<Contact>(x => x.FamilyName);

        private static PropertyChangingEventArgs _FamilyNameChangingArgs = ObservableHelper.CreateChangingArgs<Contact>(x => x.FamilyName);

        public string FamilyName
        {
            get
            {
                return Data.Name;
            }

            set
            {
                if (value != Data.Name)
                {
                    NotifyChanging(_FamilyNameChangingArgs);
                    Data.Name = value;
                    NotifyChangedAndDirty(_FamilyNameChangedArgs);
                }
            }
        }
        #endregion

        #region  GivenName
        private static PropertyChangedEventArgs _GivenNameChangedArgs = ObservableHelper.CreateChangedArgs<Contact>(x => x.GivenName);

        private static PropertyChangingEventArgs _GivenNameChangingArgs = ObservableHelper.CreateChangingArgs<Contact>(x => x.GivenName);

        public string GivenName
        {
            get
            {
                return Data.GivenName;
            }

            set
            {
                if (value != Data.GivenName)
                {
                    NotifyChanging(_GivenNameChangingArgs);
                    Data.GivenName = value;
                    NotifyChangedAndDirty(_GivenNameChangedArgs);
                }
            }
        }
        #endregion

        public string Mail { get; set; }

        public string PhoneNumber { get; set; }

        public Contact(IContactData P_Data)
            : base(P_Data)
        {
        }
    }
}
