﻿using Loki.Engine;
using Luna.Model;
using Luna.Model.Configuration;
using Luna.Model.Contacts;

namespace Luna.Services.Test
{
    public class TestApplicationModel : ObjectModel, IApplicationModel
    {
        protected override void InternalLoad()
        {
            base.InternalLoad();

            Luna.Model.Configuration.ServiceInstaller.Configuration.Install(InternalContext);
            Luna.Model.Contacts.ServiceInstaller.Contacts.Install(InternalContext);
        }

        public IConfigurationService Configuration
        {
            get { return InternalContext.Resolve<IConfigurationService>(); }
        }

        public IContactService Contacts
        {
            get { return InternalContext.Resolve<IContactService>(); }
        }
    }
}