﻿using DevExpress.Xpf.Core;
using Loki.Engine;
using Loki.UI.Wpf;

namespace Luna.UI.Wpf
{
    /// <summary>
    /// Interaction pour LunaApp.xaml.
    /// </summary>
    public partial class LunaApp : WpfBootStrapper<MainViewModel>
    {
        public LunaApp()
        {
            Theme theme = new Theme("NewTheme", "DevExpress.Xpf.Themes.NewTheme.v13.1");
            theme.AssemblyName = "DevExpress.Xpf.Themes.NewTheme.v13.1";
            Theme.RegisterTheme(theme);

            UIModel.Load += UIModel_Load;
            BootStrapper.Initializing += BootStrapper_Initializing;
        }

        private void BootStrapper_Initializing(object sender, System.EventArgs e)
        {
            Templates.LoadTemplates(Luna.UI.Wpf.ViewInstaller.All);
        }

        private void UIModel_Load(object sender, ContextLoadEventArgs e)
        {
            Luna.UI.ViewModelInstaller.All.Install(e.ObjectContext);
        }

        private ApplicationModel _ApplicationModel = new ApplicationModel();

        public override ObjectModel ApplicationModel
        {
            get
            {
                return _ApplicationModel;
            }
        }

        private DataContext _DataContext = new DataContext();

        public override ObjectModel DataModel
        {
            get
            {
                return _DataContext;
            }
        }
    }
}