﻿using Loki.Engine;
using Luna.Model;
using Luna.Model.Budget;
using Luna.Model.Configuration;
using Luna.Model.Contacts;

namespace Luna.UI.Wpf
{
    public class ApplicationModel : ObjectModel, IApplicationModel
    {
        protected override void InternalLoad()
        {
            base.InternalLoad();

            Luna.Model.Configuration.ServiceInstaller.Configuration.Install(InternalContext);

            Luna.Model.Contacts.ServiceInstaller.Contacts.Install(InternalContext);

            Luna.Model.Budget.ServiceInstaller.Budget.Install(InternalContext);
        }

        public IConfigurationService Configuration
        {
            get { return InternalContext.Resolve<IConfigurationService>(); }
        }

        public IContactService Contacts
        {
            get { return InternalContext.Resolve<IContactService>(); }
        }

        public IBudgetService Budget
        {
            get { return InternalContext.Resolve<IBudgetService>(); }
        }
    }
}