﻿using Loki.UI.Wpf;

namespace Luna.UI.Contacts.Wpf
{
    /// <summary>
    /// Logique d'interaction pour CategoryList.xaml
    /// </summary>
    public partial class CategoryListView : ViewControl<CategoryListViewModel>
    {
        public CategoryListView()
        {
            InitializeComponent();
            DataContextChanged += CategoryListView_DataContextChanged;
        }

        private void CategoryListView_DataContextChanged(object sender, System.Windows.DependencyPropertyChangedEventArgs e)
        {
            GRD_Categories.ConfigureGrid();
            GRD_Categories.OpenOnDoubleClick<DisplayableCategory>(x => x.Category);

            COL_Name.Bind<DisplayableCategory>(x => x.Name);
            COL_Description.Bind<DisplayableCategory>(x => x.Description);
        }
    }
}