﻿namespace Loki.Engine
{
    /// <summary>
    /// Interface for model engine.
    /// </summary>
    public interface IModelEngine
    {
        /// <summary>
        /// Loads the model definitions.
        /// </summary>
        /// <param name="P_ModelDefinitions">The model definitions.</param>
        void LoadModel(params string[] P_ModelDefinitions);

        /// <summary>
        /// Gets the application model.
        /// </summary>
        /// <typeparam name="TApplicationModel">The type of the application model.</typeparam>
        /// <returns></returns>
        TApplicationModel GetApplicationModel<TApplicationModel>();

        /// <summary>
        /// Gets the application model.
        /// </summary>
        /// <typeparam name="TApplicationModel">The type of the application model.</typeparam>
        /// <param name="P_ModelID">The model ID.</param>
        /// <returns></returns>
        TApplicationModel GetApplicationModel<TApplicationModel>(string P_ModelID);
    }
}
