﻿using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using Loki.Model;

namespace Loki.Engine
{
    public class ContainerConfiguration<TEntityClass, TEntityKey>
    {
        public string LoadingErrorCode
        {
            get;
            set;
        }

        public UniqueKeyConfiguration<TEntityClass, TEntityKey> PrimaryKey
        {
            get;
            set;
        }

        public IEnumerable<IIndexConfiguration<TEntityClass>> Indexes
        {
            get;
            set;
        }

        public Expression<Func<IEnumerable<TEntityClass>>> FullLoader
        {
            get;
            set;
        }

        public Action<TEntityKey> PostUpdate
        {
            get;
            set;
        }

        public Action<TEntityKey> PreUpdate
        {
            get;
            set;
        }
    }
}
