﻿using System;
using Loki.Engine;

namespace Loki
{
    public interface ITaskService
    {
        ITask CreateWorker(string P_Title, Action P_DoWork, Action P_OnComplete, Action<Exception> P_OnError);

        ITaskWithUpdate CreateUpdatetableWorker(string P_Title, Action<ITaskUpdater> P_DoWork, Action P_OnComplete, Action<Exception> P_OnError);

        ITask<TArgument> CreateWorker<TArgument, TResult>(string P_Title, Func<TArgument, TResult> P_DoWork, Action<TResult> P_OnComplete, Action<Exception> P_OnError);

        ITask<TArgument> CreateUpdatetableWorker<TArgument, TResult>(string P_Title, Action<ITaskUpdater, TArgument, TResult> P_DoWork, Action<TResult> P_OnComplete, Action<Exception> P_OnError);

        ILokiEnumerable<ITaskStatus> WorkingProcess { get; }

        ITaskStatus GetStatus(ITask P_Task);
    }
}
