﻿using System;
using Luna.Model.Configuration;

namespace Luna.Data.Configuration
{
    public class InstallDataProvider : LunaDataProvider, IInstallDataProvider
    {
        #region IInstallDataProvider Members

        public override void Initialize()
        {
            Database.Initialize();
        }

        public InstallState GetDatabaseState()
        {
            if (Database.Initialized)
            {
                return InstallState.Ok;
            }
            else
            {
                return InstallState.New;
            }
        }

        #endregion
        // {2E2F6D2B-07E6-4FB7-8B05-F8A66EE3A4D2}
        private const string _ID = "{2E2F6D2B-07E6-4FB7-8B05-F8A66EE3A4D2}";

        private const string _NAME = "Luna install data provider";

        public override Guid ID
        {
            get { return new Guid(_ID); }
        }

        public override string Name
        {
            get { return _NAME; }
        }
    }
}
