﻿using System;

namespace Loki.Commands
{
    /// <summary>
    /// Provides argument for command events.
    /// </summary>
    [Serializable]
    public class CommandEventArgs : EventArgs
    {
        /// <summary>
        /// Gets the command.
        /// </summary>
        public ICommand Command { get; private set; }

        /// <summary>
        /// Gets the command parameter.
        /// </summary>
        public object Parameter { get; private set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="CommandEventArgs"/> class.
        /// </summary>
        /// <param name="P_Command">The command.</param>
        /// <param name="P_Parameter">The parameter.</param>
        public CommandEventArgs(ICommand P_Command, object P_Parameter)
        {
            Command = P_Command;
            Parameter = P_Parameter;
        }
    }
}
