﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;

namespace Loki.Model
{
	/// <summary>
	/// Common interface for indexes configurations
	/// </summary>
	/// <typeparam name="TEntityClass">Indexed entity type</typeparam>
	public interface IIndexConfiguration<TEntityClass>
	{
		Expression<Func<TEntityClass, object>> Indexer
		{
			get;
			set;
		}

		/// <summary>
		/// Gets or sets the index specific loader.
		/// </summary>
		/// <value>The loader.</value>
		Func<object, IEnumerable<TEntityClass>> Loader
		{
			get;
			set;
		}
	}
}
