﻿// -----------------------------------------------------------------------
// <copyright file="LocalVariablePUnderscorePrefix.cs" company="AXA-IM">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace StyleCop.Extensions
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using StyleCop.CSharp;

    /// <summary>
    /// TODO: Update summary.
    /// </summary>
    [SourceAnalyzer(typeof(CsParser))]
    public class LocalVariablePUnderscorePrefix : SourceAnalyzer
    {
        public override void AnalyzeDocument(CodeDocument document)
        {
            CsDocument csdocument = (CsDocument)document;

            if (csdocument.RootElement != null && !csdocument.RootElement.Generated)
                csdocument.WalkDocument(new CodeWalkerElementVisitor<object>(this.VisitElement), null, null);
        }


        private bool VisitElement(CsElement element, CsElement parentElement, object context)
        {
            if (element.ElementType == ElementType.Method)
            {
                foreach (Variable tempVariable in element.Variables)
                {
                    //If argument type is 'EventArgs' allow non-Camel case variable name also.
                    if (!tempVariable.Type.Text.ToLower().EndsWith("EventArgs".ToLower()))
                    {
                        if (!tempVariable.Name.StartsWith("L_"))
                        {
                            base.AddViolation(element, tempVariable.Location.LineNumber, "LocalVariablePUnderscorePrefix");
                        }
                    }
                }
            }
            return true;
        }
    }
}
